//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 13-1 #3
//
// Delays for either 10 seconds or until the delay is aborted by the user
// pressing the push button.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

typedef int1 (*abort_handler)(void);

void delay_secs(int time, abort_handler func);
int1 check_c1(void);

int count;

void main(void) 
{
   for(;;)
   {
      delay_secs(10, &check_c1);
   
      printf("\r\nCount = %u", count);
      
      while(check_c1());   //wait for release
      delay_ms(250);       //debounce delay
   }
}

int1 check_c1(void)
{
   return !input(PIN_C1);
}

void delay_secs(int time, abort_handler func)
{
   count = 0;
   
   for(int i = 0; (i < (time*10)) && !func(); i++) 
   {
      delay_ms(100);
      count++;
   }
}
